//Behold... baby's first LUA spaghetti dish! Fear its overcomplicated recipe!

//a local function to make skinchecking easier
local function EmSkinCheck(player)
	if player.mo == nil
		return false
	end
	if player.mo.skin != "emmette"
		return false
	end
	return true
end

/*this function just makes different jumps easier to manage since they all share
the same setup*/
local function JumpManager(mo, height)
	if mo.eflags & MFE_VERTICALFLIP
		mo.momz = height * -1
	else
		mo.momz = height
	end
	/*this nerfs the jumps while underwater or in space so that the player 
	doesn't jump way higher underwater than on dry land*/
	if mo.eflags & MFE_UNDERWATER or mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(mo)
		if mo.eflags & MFE_VERTICALFLIP
			mo.momz = $ + ($ / 3)
		else
			mo.momz = $ - ($ / 3)
		end
	end
end

local function StateSetter(mo, sstate)
	if not (mo.state == sstate)
		mo.state = sstate
	end
end

local function CrawlNPTrigger(player)
	if not EmSkinCheck(player)
		return
	end
	
	if player.pound == nil
		player.pound = false
	end
	//this makes the player crawl if they hold spin while on the ground
	if P_IsObjectOnGround(player.mo)
		player.height = player.spinheight
		if player.mo.momx >= 4 * FRACUNIT
			player.mo.momx = 4 * FRACUNIT
		elseif player.mo.momx <= -4 * FRACUNIT
			player.mo.momx = -4 * FRACUNIT
		end
		if player.mo.momy >= 4 * FRACUNIT
			player.mo.momy = 4 * FRACUNIT
		elseif player.mo.momy <= -4 * FRACUNIT
			player.mo.momy = -4 * FRACUNIT
		end
		player.pflags = $ | PF_JUMPSTASIS
		if player.mo.momx != 0 and player.mo.momy != 0
			StateSetter(player.mo, S_PLAY_CLIMB)
		else
			StateSetter(player.mo, S_PLAY_GLIDE)
		end
	/*this triggers the boolean that runs the ground pound code if the player
	presses spin while in the air*/
	elseif (player.pflags & PF_JUMPED or player.mo.state == S_PLAY_FALL) and 
			player.powers[pw_carry] == CR_NONE and not (player.mo.state ==
			S_PLAY_CLING)
		player.mo.momx = 0
		player.mo.momy = 0
		JumpManager(player.mo, 7 * FRACUNIT)
		player.hover = 1 * TICRATE
		player.pflags = $ & ~PF_THOKKED
		player.pound = true
	end
	return true
end
addHook("SpinSpecial", CrawlNPTrigger)

//this makes the player spin, since a lot of abilities make them spin
local function Speening(player)
	if player.speen == nil
		player.speen = 0
	end
	player.speen = $ - 37
	player.drawangle = FixedAngle(player.speen * FRACUNIT)
end

local function GroundPound(player)
	if not EmSkinCheck(player)
		return
	end
	
	//this resets the height and speed changes made by crawling
	if player.powers[pw_carry] == CR_NIGHTSMODE
		player.height = 46 * FRACUNIT
	elseif not (input.gameControlDown(GC_SPIN) and P_IsObjectOnGround(player.mo))
		player.height = skins[player.mo.skin].height
		if player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_CLIMB
			player.mo.state = S_PLAY_WALK
		end
	end
	//this is the ground pound code
	if P_PlayerInPain(player) or player.playerstate == PST_DEAD or 
			player.mo.state == S_PLAY_STUN
		player.pound = false
		return
	end
	if player.groundpound == nil
		player.groundpound = false
	end
	if player.pound
		player.pflags = $ | PF_FULLSTASIS
		if player.hover > 0
			if player.mo.momz == 0
				player.mo.momz = 0
			end
			StateSetter(player.mo, S_PLAY_GLIDE_LANDING)
			player.hover = $ - 8
		elseif not player.groundpound
			JumpManager(player.mo, -50 * FRACUNIT)
			player.groundpound = true
		else
			if player.mo.eflags & MFE_GOOWATER or player.powers[pw_carry] != 
					CR_NONE or (player.mo.momz > 0 and not (player.mo.eflags & 
					MFE_VERTICALFLIP)) or (player.mo.momz < 0 and 
					player.mo.eflags & MFE_VERTICALFLIP)
				if player.powers[pw_carry] != CR_NONE
					player.mo.state = S_PLAY_WALK
				elseif not (player.mo.state == S_PLAY_SPRING or player.mo.eflags
						& MFE_GOOWATER)
					JumpManager(player.mo, 7 * FRACUNIT)
					player.mo.state = S_PLAY_JUMP
				end
				player.groundpound = false
				player.pound = false
			elseif not P_IsObjectOnGround(player.mo)
				Speening(player)
				StateSetter(player.mo, S_PLAY_MELEE)
				player.powers[pw_strong] = STR_FLOOR|STR_SPRING|STR_HEAVY|
						STR_STOMP|STR_ANIM
			else
				S_StartSound(player.mo, sfx_pstop)
				local px = player.mo.x
				local py = player.mo.y
				local br = 75 * FRACUNIT
				local mo = player.mo
				P_Earthquake(player.mo, player.mo, 90 * FRACUNIT)
				searchBlockmap("objects", function(mo, found)
					if found and found.valid and found.health and 
							P_CheckSight(mo, found) and (found.z < mo.z + 
							mo.height / 2 and found.z > mo.z - mo.height / 2)
						P_DamageMobj(found, mo, mo, 1, 0)
					end
				end, mo, px-br, px+br, py-br, py+br)
				JumpManager(player.mo, 7 * FRACUNIT)
				player.mo.state = S_PLAY_JUMP
				player.groundpound = false
				player.pound = false
			end
		end
	end
end
addHook("PlayerThink", GroundPound)

//these handle dust spawning for all the different jumps, since it's used a lot
local function DustSpawners(orimo, dist, airmo, watermo)
	if orimo.eflags & MFE_UNDERWATER or orimo.eflags & MFE_GOOWATER
		P_SpawnMobjFromMobj(orimo, dist, 0, 0, watermo)
		P_SpawnMobjFromMobj(orimo, dist * -1, 0, 0, watermo)
		P_SpawnMobjFromMobj(orimo, 0, dist, 0, watermo)
		P_SpawnMobjFromMobj(orimo, 0, dist * -1, 0, watermo)
	else
		P_SpawnMobjFromMobj(orimo, dist, 0, 0, airmo)
		P_SpawnMobjFromMobj(orimo, dist * -1, 0, 0, airmo)
		P_SpawnMobjFromMobj(orimo, 0, dist, 0, airmo)
		P_SpawnMobjFromMobj(orimo, 0, dist * -1, 0, airmo)
	end
end
local function SpawnDust(player)
	DustSpawners(player.mo, 30 * FRACUNIT, MT_ARIDDUST, MT_MEDIUMBUBBLE)
end
local function SpawnMoreDust(player)
	SpawnDust(player)
	DustSpawners(player.mo, 60 * FRACUNIT, MT_DUST, MT_SMALLBUBBLE)
end
local function SpawnTornadoDust(player)
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
		local tornadobubble = P_SpawnMobjFromMobj(player.mo, 0, 0, 0,
				MT_EXTRALARGEBUBBLE)
		tornadobubble.customAI = true
	else
		P_SpawnThokMobj(player)
	end
end
//this ensures any bubbles spawned in SpawnTornadoDust gets eventually removed
local function TornadoBubbles(mo)
	if mo.customAI == nil or not mo.customAI
		return
	end
	
	if mo.thinktimer == nil
		mo.thinktimer = 3 * TICRATE
	end
	if mo.thinktimer <= 0
		P_RemoveMobj(mo)
	else
		mo.thinktimer = $ - 1
	end
	return
end
addHook("MobjThinker", TornadoBubbles, MT_EXTRALARGEBUBBLE)

//this function handles the underwater/space nerfs for horizontal dashes
local function DiveNerfs(mo, divespeed)
	if mo.eflags & MFE_UNDERWATER or mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(mo)
		divespeed = $ - ($ / 3)
	end
	return divespeed
end

local function LongJumpTornado(player)
	if not EmSkinCheck(player)
		return
	end
	
	if player.highthirdjumped == nil
		player.highthirdjumped = 0
	end
	if P_PlayerInPain(player) or player.playerstate == PST_DEAD or 
			player.powers[pw_carry] != CR_NONE
		return
	end
	if P_IsObjectOnGround(player.mo)
		player.highthirdjumped = 0
	end
	//This makes the player spin in the air while high-jumping
	if player.pflags & PF_THOKKED and not player.pound
		if (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz <= 0
			Speening(player)
			if player.mo.momz / FRACUNIT < -10
				SpawnTornadoDust(player)
			end
		elseif not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz >= 0
			Speening(player)
			if player.mo.momz / FRACUNIT > 10
				SpawnTornadoDust(player)
			end
		else
			StateSetter(player.mo, S_PLAY_FALL)
		end
	end
	if player.hasdived == nil
		player.hasdived = false
	end
	if input.gameControlDown(GC_CUSTOM1) and not player.pound
		//this makes the player dive if they press custom 1 on the ground
		if P_IsObjectOnGround(player.mo)
			if not player.hasdived
				S_StartSound(player.mo, sfx_s3k4b)
				JumpManager(player.mo, 5 * FRACUNIT)
				P_InstaThrust(player.mo, player.mo.angle, DiveNerfs(player.mo, 
						40 * FRACUNIT))
				player.mo.state = S_PLAY_ROLL
				player.powers[pw_strong] = STR_WALL|STR_ANIM
				player.pflags = $ | PF_SPINNING
				player.hasdived = true
			end
		/*this makes the player do a deadly tornado glide if they hold custom 1
		while in the air*/
		elseif not player.hasdived
			P_SpawnSkidDust(player, 25 * FRACUNIT)
			if not S_SoundPlaying(player.mo, sfx_prloop)
				S_StartSound(player.mo, sfx_prloop, player)
			end
			Speening(player)
			StateSetter(player.mo, S_PLAY_CLING)
			player.pflags = $ & ~PF_THOKKED
			player.powers[pw_strong] = STR_ATTACK|STR_SPIKE|STR_ANIM
			if (player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz >= 2 * 
					FRACUNIT) or (not (player.mo.eflags & MFE_VERTICALFLIP) and 
					player.mo.momz <= -2 * FRACUNIT)
				JumpManager(player.mo, -2 * FRACUNIT)
			end
		end
	else
		if P_IsObjectOnGround(player.mo)
			player.hasdived = false
		end
		if player.mo.state == S_PLAY_CLING
			player.mo.state = S_PLAY_FALL
		end
	end
	//this spawns a ghost trail if the player has dived
	if player.hasdived and player.mo.state == S_PLAY_ROLL
		P_SpawnGhostMobj(player.mo)
	end
end
addHook("PlayerThink", LongJumpTornado)

/*this nerfs her wind abilities while underwater or in space so long as she
doesn't have any air-based shields*/
local function WaterShieldCheck(player, height)
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(player.mo)
		if not (player.powers[pw_shield] == SH_WHIRLWIND or 
				player.powers[pw_shield] & SH_PROTECTWATER)
			return height / 2
		end
	end
	return height
end

local function HighNThirdJump(player)
	if not EmSkinCheck(player)
		return
	end
	
	/*this makes it so the player can't high jump if they're long jumping or
	doing the tornado*/
	if player.haslongjumped or player.mo.state == S_PLAY_CLING
		return true
	end
	//this makes the player perform the high jump
	if player.highthirdjumped <= 0
		player.mo.state = S_PLAY_SPINDASH
		SpawnMoreDust(player)
		S_StartSound(player.mo, sfx_wdjump)
		player.pflags = $ | PF_THOKKED
		JumpManager(player.mo, WaterShieldCheck(player, 20 * FRACUNIT))
		player.mo.momx = $ / 4
		player.mo.momy = $ / 4
		player.highthirdjumped = 1
	/*this makes the player perform an extra little hop that thrusts the
	player forward after high-jumping*/
	elseif player.highthirdjumped == 1
		player.mo.state = S_PLAY_FLOAT
		SpawnDust(player)
		S_StartSound(player.mo, sfx_wirlsg)
		P_InstaThrust(player.mo, player.mo.angle, DiveNerfs(player.mo, 
				player.normalspeed))
		player.pflags = $ | PF_THOKKED
		JumpManager(player.mo, WaterShieldCheck(player, 7 * FRACUNIT))
		player.highthirdjumped = 2
	end
	return true
end
addHook("AbilitySpecial", HighNThirdJump)

local function Footsteps(mo, fram1, step1, fram2, step2)
	if mo.currentfram == nil
		mo.currentfram = -1
	end
	if mo.currentfram != (mo.frame & FF_FRAMEMASK)
		if (mo.frame & FF_FRAMEMASK) == fram1
			S_StartSound(mo, step1, mo.player)
		elseif (mo.frame & FF_FRAMEMASK) == fram2 and fram2 != nil
			if step2 == nil
				step2 = step1
			end
			S_StartSound(mo, step2, mo.player)
		end
		mo.currentfram = mo.frame & FF_FRAMEMASK
	end
end

local function MiscStuff(player)
	if not EmSkinCheck(player)
		return
	end
	
	//this allows the player to breathe underwater and in space due to nerfs
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
		player.powers[pw_underwater] = $ + 1
	elseif P_InSpaceSector(player.mo)
		player.powers[pw_spacetime] = $ + 1
	end
	//this controls the sound effects for walking and running and crawling
	if player.footcue == nil
		player.footcue = false
	end
	if P_IsObjectOnGround(player.mo)
		if player.mo.state == S_PLAY_WALK
			Footsteps(player.mo, 1, sfx_putput, 4, sfx_pudpud)
		elseif player.mo.state == S_PLAY_RUN
			Footsteps(player.mo, 1, sfx_spndsh, 2, sfx_gasp)
		elseif player.mo.state == S_PLAY_CLIMB
			Footsteps(player.mo, 0, sfx_thok, 2)
		end
	end
	//this is the secret bit, not finished yet
	/*if player.wickedplaying == nil
		player.wickedplaying = false
	end
	if input.gameControlDown(GC_CUSTOM3) and input.gameControlDown(GC_TOSSFLAG)
			and P_IsObjectOnGround(player.mo) and player.mo.momx == 0 and
			player.mo.momy == 0
		if not player.wickedplaying
			S_ChangeMusic("WICKED", true, player, 0, 0, 0, 0)
			player.wickedplaying = true
		end
	elseif not P_IsObjectOnGround(player.mo) or player.mo.momx != 0 or
			player.mo.momy != 0 and player.wickedplaying
		P_RestoreMusic(player)
	end*/
end
addHook("PlayerThink", MiscStuff)

//this makes it so the player can't grab air bubbles, since they don't need it
local function NoBubbles(special, toucher)
	if toucher.skin == "emmette"
		return true
	end
end
addHook("TouchSpecial", NoBubbles, MT_EXTRALARGEBUBBLE)